<?php

/* 
 * Admin menu for ELiS Library
 * @author Arsen I. Borovinskiy
 */

function elis_admin_shell_form($form) {
  $last_result = is_object(cache_get('elis_admin_shell_last_results')) ? cache_get('elis_admin_shell_last_results')->data : false; // get last result of execute form
  if ($last_result != false && !is_string($last_result)) $last_result = '';
  $form['elis_shell_command'] = array(
    '#type' => 'textfield',
    '#title' => 'ELiS shell command',
    '#required' => TRUE,
    '#description' => 'Команда для выполнения на сервере ELiS в /bin/sh (Примеры: "df -h", "cat /proc/cpuinfo", "mount") или drush-команда (Примеры: "drush en ldap", "drush cc all"). При этом если команда начинается с drush, переход в /var/www/vh/library делать не надо.',
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Submit',
  );
  if ($last_result && $last_result != '') {
    $form['submit']['#suffix'] = $last_result;
    cache_set('elis_admin_shell_last_results','');
  }
  return $form;
}

function elis_admin_shell_form_validate($form,&$form_state) {
  $form_state['cache'] = FALSE;
  if (strlen($form_state['values']['elis_shell_command']) == 0) {
    form_set_error('elis_shell_command','Set command for shell execute.');
  }
}

function elis_admin_shell_form_submit($form,$form_state) {
  $cmd = $form_state['values']['elis_shell_command'];
  if (strpos($cmd, 'drush') === 0) {
    if (strpos($cmd, 'drush -y') !== 0) {
      $cmd = preg_replace("/^drush/","drush -y", $cmd); // auto add -y for all drush commands
    }
    $cmd = 'cd /var/www/vh/library && ' . $cmd;
  }
  $output = '';
  try {
    exec($cmd, $cmd_out, $result_code);
    $output .= 'result code: ' . $result_code . "\n";
    $output .= implode("\n", $cmd_out);
    $output = '<pre>' . filter_xss($cmd) . "\n" . filter_xss($output) . '</pre>';
  } catch (Exception  $err) {
    $output .= 'error code: ' . filter_xss($err->getCode()) . ' message:' . filter_xss($err->getMessage());
  }
  cache_set('elis_admin_shell_last_results', $output);
}






